//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include "FPanel.h"
#include "ShortCuts.h"
#pragma resource "FComponents.res"
#pragma hdrstop
#pragma option -5 -O2 -OS -d- -fp -O -Oi -Ov -vi- -w-eas

__fastcall FPanel::FPanel(TComponent* Owner)
	: TCustomPanel(Owner) {
 Bt = CreateFCustomButton();
 Width = 160;
 Height = 192;
 Caption = "";
 rect1.Left = 2;
 rect1.Top = 9;
 rect1.Right = Width - 3;
 rect1.Bottom = Height - 3;
 rect2.Left = 3;
 rect2.Top = 10;
 rect2.Right = Width - 2;
 rect2.Bottom = Height - 2;
 FHeightBegin = 24;
 FHeightEnd = 192;
 anim = false;
 FFast = false;
 FFastValue = 2;
 FBtCaption = "DropDown";
 init = true;
}

namespace Fpanel {
 void __fastcall Register()	{
  TComponentClass classes[1] = {__classid(FPanel)};
  RegisterComponents("FLoh!", classes, 0);
 }
}

FPanel::FCustomButton *__fastcall FPanel::CreateFCustomButton() {
 FCustomButton *b = new FCustomButton((TComponent *)this);
 b->Parent = this;
 b->Visible = true;
 b->Caption = FBtCaption;
 b->OnClick = OnBtClick;
 return b;
}

void __fastcall FPanel::Paint() {
 Canvas->Brush->Color = clGray;
 Canvas->FrameRect(rect1);
 Canvas->Brush->Color = clWhite;
 Canvas->FrameRect(rect2);
}

void __fastcall FPanel::SetBounds(int l, int t, int w, int h) {
 if (w < 128) { w = 128; }
 if (h < 24) { h = 24; }
 TCustomPanel::SetBounds(l,t,w,h);
 if ((init) && (Bt->init)) {
  Bt->SetBounds(5,0,Width - 10, 16);
 }
 rect1.Left = 2;
 rect1.Top = 9;
 rect1.Right = Width - 3;
 rect1.Bottom = Height - 3;
 rect2.Left = 3;
 rect2.Top = 10;
 rect2.Right = Width - 2;
 rect2.Bottom = Height - 2;
 if ((PanelUp) && (!anim)) { HeightUp = h; }
 if ((!PanelUp) && (!anim)) { HeightDown = h; }
}

void __fastcall FPanel::SetFBtCaption(AnsiString s) {
 Bt->Caption = s;
 FBtCaption = s;
}

void __fastcall FPanel::SetFHeightBegin(int i) {
 if (FHeightBegin != i) {
  if (i > 23) { FHeightBegin = i; }
  else { FHeightBegin = 24; }
 }
}

void __fastcall FPanel::SetFHeightEnd(int i) {
 if (FHeightEnd != i) {
  if (FHeightEnd > FHeightBegin) {
   FHeightEnd = i;
   if (!PanelUp) { Height = i; }
  }
 }
}

void __fastcall FPanel::OnBtClick(TObject *S) {
 switch(FPanelUp) {
  case true: AnimDown(); return;
  case false: AnimUp(); return;
 }
}

void __fastcall FPanel::SetFPanelUp(bool b) {
 if (FPanelUp != b) {
  FPanelUp = b;
  switch(b) {
   case true: AnimUp(); return;
   case false: AnimDown(); return;
  }
 }
}

void FPanel::AnimUp() {
 Bt->PlusMinus = "+";
 FPanelUp = true;
 Bt->nopaint = true;
 anim = true;
 TComponentState CS;
 CS = ComponentState;
 CS = CS << csDesigning;
 if (CS != ComponentState) {
  for (register int i = HeightDown; i >= HeightUp; i -= FFastValue) {
   Height = i;
   if (ControlCount > 2) {
    for (register int c = 1; c < ControlCount; c++) {
     Controls[c]->Top -= FFastValue;
     if (Controls[c]->Top < 20) { Controls[c]->Hide(); }
    }
   }
   else if (ControlCount == 2) {
    Controls[1]->Top -= FFastValue;
    if (Controls[1]->Top < 20) { Controls[1]->Hide(); }
   }
   Update();
  }
 }
 else { Height = HeightUp; }
 Bt->nopaint = false;
 anim = false;
 Bt->Update();
}

void FPanel::AnimDown() {
 Bt->PlusMinus = "-";
 FPanelUp = false;
 Bt->nopaint = true;
 anim = true;
 TComponentState CS;
 CS = ComponentState;
 CS = CS << csDesigning;
 if (CS != ComponentState) {
  for (register int i = HeightUp; i <= HeightDown; i += FFastValue) {
   Height = i;
   if (ControlCount > 2) {
    for (register int c = 1; c < ControlCount; c++) {
     Controls[c]->Top += FFastValue;
     if (Controls[c]->Top < 20) { Controls[c]->Show(); }
    }
   }
   else if (ControlCount == 2) {
    Controls[1]->Top += FFastValue;
    if (Controls[1]->Top < 20) { Controls[1]->Show(); }
   }
   Update();
  }
 }
 else { Height = HeightDown; }
 Bt->nopaint = false;
 anim = false;
 Bt->Update();
}

void __fastcall FPanel::SetFColor(TColor c) {
 Bt->SignColor = c;
 Bt->PaintPM();
 FColor = c;
}

void _fastcall FPanel::SetFFast(Boolean b) {
 FFast = b;
 switch(b) {
  case true: FFastValue = 4;
  case false: FFastValue = 2;
 }
}
// --------------- FCustomButton -----------------------
__fastcall FPanel::FCustomButton::FCustomButton(TComponent* Owner)
    : TCustomControl(Owner) {
 Width = 118;
 Height = 14;
 MouseOver = false;
 mousedown = false;
 Visible = false;
 Color = clSilver;
 Font->Size = 8;
 Font->Name = "MS Sans Serif";
 Font->Color = clBlack;
 Canvas->Font = Font;
 ControlStyle = ControlStyle << csOpaque;
 Canvas->Brush->Color = clSilver;
 FPM = "-";
 nopaint = false;
 SignColor = clBlack;
 init = true;
}

void __fastcall FPanel::FCustomButton::Paint() {
 if (!nopaint) {
  Canvas->FillRect(rect);
  if ((!mousedown) && (MouseOver)) {
   Canvas->Pen->Color = clWhite;
   Canvas->MoveTo(0,Height + 1);
   Canvas->LineTo(0,0);
   Canvas->LineTo(Width + 1,0);
   Canvas->Pen->Color = clGray;
   Canvas->MoveTo(Width - 1,0);
   Canvas->LineTo(Width - 1,Height - 1);
   Canvas->LineTo(0,Height - 1);
   PaintText();
   return;
  }
  if ((!mousedown) && (!MouseOver)) {
   PaintText();
   TComponentState CS;
   CS = ComponentState;
   CS = CS >> csDesigning;
   if (CS != ComponentState) {
    Canvas->Pen->Color = clWhite;
    Canvas->MoveTo(0,Height + 1);
    Canvas->LineTo(0,0);
    Canvas->LineTo(Width + 1,0);
    Canvas->Pen->Color = clGray;
    Canvas->MoveTo(Width - 1,0);
    Canvas->LineTo(Width - 1,Height - 1);
    Canvas->LineTo(0,Height - 1);
    PaintText();
   }
   return;
  }
  if (mousedown) {
   Canvas->FillRect(rect);
   Canvas->Pen->Color = clGray;
   Canvas->MoveTo(0,Height + 1);
   Canvas->LineTo(0,0);
   Canvas->LineTo(Width + 1,0);
   Canvas->Pen->Color = clWhite;
   Canvas->MoveTo(Width - 1,0);
   Canvas->LineTo(Width - 1,Height - 1);
   Canvas->LineTo(0,Height - 1);
   PaintText();
   return;
  }
 }
}

void __fastcall FPanel::FCustomButton::PaintText() {
 Canvas->Brush->Color = Color;
 Canvas->TextOut(w2 - (Canvas->TextWidth(Caption) / 2) - 1,h2 - (Canvas->TextHeight(Caption) / 2),Caption);
 PaintPM();
}

void __fastcall FPanel::FCustomButton::MouseDown(TMouseButton mb, TShiftState s, int X, int Y) {
 if (mb == mbLeft) {
  mousedown = true;
  Repaint();
 }
}

void __fastcall FPanel::FCustomButton::MouseUp(TMouseButton mb, TShiftState s, int X, int Y) {
 if (mb == mbLeft) {
  mousedown = false;
  Repaint();
 }
}

void __fastcall FPanel::FCustomButton::CMMouseEnter(TMessage *m) {
 MouseOver = true; Repaint();
}

void __fastcall FPanel::FCustomButton::CMMouseLeave(TMessage *m) {
 MouseOver = false; Repaint();
}

void __fastcall FPanel::FCustomButton::SetBounds(int l, int t, int w, int h) {
 if (init) {
  if (w < 96) { w = 96; }
  if (h < 10) { h = 10; }
 }
 TCustomControl::SetBounds(l,t,w,h);
 rect.Left = 0;
 rect.Top = 0;
 rect.Right = w;
 rect.Bottom = h;
}

void __fastcall FPanel::FCustomButton::SetFPM(AnsiString s) {
 FPM = s;
 Repaint();
}

void FPanel::FCustomButton::PaintPM() {
 if (FPM == "+") {
  Canvas->Pen->Width = 2;
  Canvas->Pen->Color = SignColor;
  Canvas->MoveTo(4,8);
  Canvas->LineTo(10,8);
  Canvas->MoveTo(7,5);
  Canvas->LineTo(7,11);
  Canvas->Pen->Width = 1;
  return;
 }
 if (FPM == "-") {
  Canvas->Pen->Width = 2;
  Canvas->Pen->Color = SignColor;
  Canvas->MoveTo(4,8);
  Canvas->LineTo(10,8);
  Canvas->Pen->Width = 1;
  return;
 }
}
