//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include "FSchalter.h"
#include "ShortCuts.h"
#pragma resource "FComponents.res"
#pragma hdrstop
#pragma option -5 -O2 -OS -d- -fp -O -Oi -Ov -vi- -w-eas

__fastcall FSchalter::FSchalter(TComponent* Owner)
	: TGraphicControl(Owner) {
 Height = 64;
 Width = 32;
 FUp = true;
 Visible = true;
}

namespace Fschalter {
 void __fastcall Register() 	{
  TComponentClass classes[1] = {__classid(FSchalter)};
  RegisterComponents("FLoh!", classes, 0);
 }
}

void __fastcall FSchalter::Paint() {
 switch (FUp) {
  case true: PaintUp(); return;
  case false: PaintDown(); return;
 }
}

void FSchalter::PaintUp() {
 POINT p1a;
 POINT p2a;
 POINT p3a;
 POINT p4a;
 POINT pointsa[4];
 p1a.x = 14;
 p1a.y = 32;
 p2a.x = 17;
 p2a.y = 10;
 p3a.x = 23;
 p3a.y = 10;
 p4a.x = 18;
 p4a.y = 32;
 pointsa[0] = p1a;
 pointsa[1] = p2a;
 pointsa[2] = p3a;
 pointsa[3] = p4a;
 pointsa[4] = p1a;
 Canvas->Brush->Color = clSilver;
 Canvas->Pen->Color = clGray;
 Canvas->RoundRect(0,0,32,64,8,8);
 Canvas->MoveTo(3,4);
 Canvas->LineTo(27,4);
 Canvas->LineTo(27,60);
 Canvas->LineTo(3,60);
 Canvas->LineTo(3,4);
 Canvas->Pen->Color = 0x00dcdcdc;
 Canvas->MoveTo(4,61);
 Canvas->LineTo(4,5);
 Canvas->LineTo(28,5);
 Canvas->Pen->Color = clBlack;
 Canvas->LineTo(28,61);
 Canvas->LineTo(4,61);
 Canvas->Brush->Color = clGray;
 Canvas->Ellipse(6,22,26,42);
 Canvas->Ellipse(13,29,19,35);
 Canvas->Ellipse(2,2,6,6);
 Canvas->Ellipse(2,58,6,62);
 Canvas->Ellipse(26,2,30,6);
 Canvas->Ellipse(26,58,30,62);
 Canvas->Pen->Color = clSilver;
 Canvas->Arc(7,23,25,41,32,16,0,48);
 Canvas->Pen->Color = clBlack;
 Canvas->Arc(7,23,25,41,0,48,32,16);
 Canvas->Pen->Color = clSilver;
 Canvas->MoveTo(14,32);
 Canvas->Polygon(pointsa,4);
 Canvas->Pen->Color = 0x00dcdcdc;
 Canvas->MoveTo(14,32);
 Canvas->LineTo(17,10);
 Canvas->Pen->Color = 0x00070707;
 Canvas->MoveTo(18,32);
 Canvas->LineTo(23,10);
 Canvas->Brush->Color = clGray;
 Canvas->Pen->Color = clBlack;
 Canvas->Ellipse(18,8,24,12);
 return;
}

void FSchalter::PaintDown() {
 POINT p1b;
 POINT p2b;
 POINT p3b;
 POINT p4b;
 POINT pointsb[4];
 p1b.x = 14;
 p1b.y = 32;
 p2b.x = 17;
 p2b.y = 54;
 p3b.x = 23;
 p3b.y = 54;
 p4b.x = 18;
 p4b.y = 32;
 pointsb[0] = p1b;
 pointsb[1] = p2b;
 pointsb[2] = p3b;
 pointsb[3] = p4b;
 pointsb[4] = p1b;
 Canvas->Brush->Color = clSilver;
 Canvas->Pen->Color = clGray;
 Canvas->RoundRect(0,0,32,64,8,8);
 Canvas->MoveTo(3,4);
 Canvas->LineTo(27,4);
 Canvas->LineTo(27,60);
 Canvas->LineTo(3,60);
 Canvas->LineTo(3,4);
 Canvas->Pen->Color = 0x00dcdcdc;
 Canvas->MoveTo(4,61);
 Canvas->LineTo(4,5);
 Canvas->LineTo(28,5);
 Canvas->Pen->Color = clBlack;
 Canvas->LineTo(28,61);
 Canvas->LineTo(4,61);
 Canvas->Brush->Color = clGray;
 Canvas->Ellipse(6,22,26,42);
 Canvas->Ellipse(13,29,19,35);
 Canvas->Ellipse(2,2,6,6);
 Canvas->Ellipse(2,58,6,62);
 Canvas->Ellipse(26,2,30,6);
 Canvas->Ellipse(26,58,30,62);
 Canvas->Pen->Color = clSilver;
 Canvas->Arc(7,23,25,41,32,16,0,48);
 Canvas->Pen->Color = clBlack;
 Canvas->Arc(7,23,25,41,0,48,32,16);
 Canvas->Pen->Color = clSilver;
 Canvas->MoveTo(14,32);
 Canvas->Polygon(pointsb,4);
 Canvas->Pen->Color = 0x00dcdcdc;
 Canvas->MoveTo(14,32);
 Canvas->LineTo(17,54);
 Canvas->Pen->Color = 0x00070707;
 Canvas->MoveTo(18,32);
 Canvas->LineTo(23,54);
 Canvas->Brush->Color = clGray;
 Canvas->Pen->Color = clBlack;
 Canvas->Ellipse(18,52,24,56);
 return;
}

void __fastcall FSchalter::SetUp(Boolean b) {
 FUp = b;
 Repaint();
}

void __fastcall FSchalter::MouseDown(TMouseButton B, TShiftState S, int x, int y) {
 if (B == mbLeft) {
  switch (FUp) {
   case false: FUp = true; Repaint(); return;
   case true: FUp = false; Repaint(); return;
  }
 }
}

void __fastcall FSchalter::SetBounds(int l, int t, int w, int h) {
 TGraphicControl::SetBounds(l,t,32,64);
}
